#ifndef _include_bleifrei_gfx_EffectManager_hpp_
#define _include_bleifrei_gfx_EffectManager_hpp_ 
//----------------------------------------------------------------------------------------------------------------------
#include "../Singleton.hpp"
#include "CgFX.hpp"
#include <map>
#include <string>
//----------------------------------------------------------------------------------------------------------------------
namespace bleifrei {
	namespace gfx {
//----------------------------------------------------------------------------------------------------------------------
class Effect;
//----------------------------------------------------------------------------------------------------------------------

class EffectManager : public Singleton<EffectManager>
{
	friend class Singleton<EffectManager>;
public:
	bool init(const std::string &path = "");
	void destroy(void);

	Effect *load(const std::string &filename);
	Effect *reload(const std::string &filename);
	
	CGcontext cg_getContext() { return m_cgContext; }

private:
	EffectManager(void);
	~EffectManager(void);

	std::map<std::string, Effect *> m_effects;
	std::string m_effectPath;
	CGcontext m_cgContext;
};

//----------------------------------------------------------------------------------------------------------------------
	}
}
//----------------------------------------------------------------------------------------------------------------------
#endif //_include_bleifrei_gfx_EffectManager_hpp_
