
#ifndef _include_bleifrei_System_hpp_
#define _include_bleifrei_System_hpp_ 

// includes
#include "../platform/windows.hpp"
#include <string>

#include "../Singleton.hpp"
#include "Timer.hpp"

int WINAPI WndMain(HINSTANCE, HINSTANCE, char *, int);

namespace bleifrei {
	namespace platform {

		class System : public Singleton<System>
		{
			friend class Singleton<System>;
		public:
			bool init(void);
			void destroy(void);

			void resetTimer(void);
			bool update(void);
			void shutdown(void)										{ PostQuitMessage(0);							}
			float getFrameTime(void)								{ return m_frameTime;							}

		private:
			System(void) {}
			~System(void) {}

		// Windows specific
		public:
			void windows_setInstanceHandle(HINSTANCE instance)		{ instanceHandle = instance;					}
			HINSTANCE windows_getInstanceHandle(void)				{ return instanceHandle;						}

			static LRESULT CALLBACK windows_callback(HWND windowHandle, UINT message, WPARAM wParam, LPARAM lParam);
			
		private:
			HINSTANCE instanceHandle;
			Timer m_timer;
			float m_frameTime;
		};

	}
}


#endif //_include_bleifrei_System_hpp_
